/*

Serial port Compact Flash data logger based for PIC 18F uCs
To be compiled with HI-TECH PIC18 Compilers
Freely distributable in this original form.
(c) 2006 Pasan Hettiarachchi
(c) Microsolutions
Any questions or comments?  admin@microsolutions.info

Derived from folllowing existing source codes
Compact Flash access: MintyMP3 project, http://www.ladyada.net/make/minty/ 
Copyright (c) 2004 Limor Fried <ladyada@media.mit.edu>

*/

#ifndef __CF_H
#define __CF_H

#define CF_A       		LATE
#define CF_DATA_OUT    	LATD
#define CF_DATA_IN    	PORTD
#define CF_DATA_DIR    	TRISD

#define CF_CONTROL		LATA
#define CF_OE      		LATA2
#define CF_WE      		LATA3
#define CF_READY   		RA5
#define CF_RESET   		LATA1
#define CF_CD      		RA4
#define CF_CE	   		LATA2
#define INPUT_PORT  	0xFF  	// 11111111
#define OUTPUT_PORT 	0x00  	// 00000000






#define  REG_DATA			0x00	// ADDRESS OF DATA REGISTER
#define  REG_ERROR			0x01	// ADDRESS OF ERROR REGISTER
#define  REG_FEATURES		0x01	// ADDRESS OF FEATURES REGISTER
#define  REG_SECTORCOUNT	0x02	// ADDRESS OF SECTOR COUNT REGISTER
#define  REG_SECTORNUM		0x03	// ADDRESS OF SECTOR NUMBER REGISTER
#define  REG_CYLINDERLOW	0x04	// ADDRESS OF LOW CYLINDER REGISTER
#define  REG_CYLINDERHIGH	0x05	// ADDRESS OF HIGH CYLINDER REGISTER
#define  REG_HEAD			0x06	// ADDRESS OF HEAD/DRIVE REGISTER
#define  REG_STATUS			0x07	// ADDRESS OF STATUS REGISTER
#define  REG_COMMAND		0x07	// ADDRESS OF COMMAND REGISTER


#define COMMAND_IDENTIFY	0xEC
#define COMMAND_WRITESECTOR	0x30
#define COMMAND_READSECTOR	0x20
#define COMMAND_DIAGNOSTIC 	0x90


#define CF_OK 0
#define NO_CF 1


void waitforready();  
unsigned char is_CF_Out();
void CF_ResetCard(void);

unsigned char CF_ReadByte(void);
void CF_WriteByte(unsigned char data);
unsigned char CF_init(void);
void CF_TaskFileWrite(unsigned char addr, unsigned char data);
unsigned char CF_TaskFileRead(unsigned char addr);
void CF_WriteInt(unsigned int data);
unsigned int CF_ReadInt(void);
void CF_WriteLong(unsigned long data);
unsigned long CF_ReadLong(void);
void CF_ReadSkipBytes(unsigned int count);
void CF_WriteSkipBytes(unsigned int count);
void CF_ReadSkipInt(unsigned char count);
unsigned char CF_isBusy(void);
unsigned char CF_isReady(void);

void CF_Disable(void);
unsigned char CF_Enable(void);
void CF_StartSectorRead();
void CF_StartSectorWrite();

void CF_ReadSectorIntoBuff();
void CF_WriteBuffIntoSector();
void CF_DumpSector();

#endif
