/**	LCD interface header file
*
**/


#ifndef _LCD_H_
#define _LCD_H_


#define LCD_WAIT DelayUs(50)


#define MESSAGE_LINE		0x0

#define LCD_RS	LATB6
#define LCD_EN	LATB5
#define LCD_DATA	LATD

#define LCD_RS_TRIS	TRISB6
#define LCD_EN_TRIS	TRISB5
#define LCD_DATA_TRIS	TRISD


#define OUTPUT_PIN      0x0	
#define INPUT_PIN       0x1	
#define OUTPUT_DATA     0x0	
#define INPUT_DATA      0xFF

#define LCD_STROBE()	LCD_EN = 1; asm("nop"); asm("nop"); LCD_EN = 0



#define	lcd_cursor(x)			lcd_cmd(((x)&0x7F)|0x80)
#define lcd_clear()				lcd_cmd(0x1)

#define lcd_goto(x)				lcd_cmd(0x80+(x))
#define lcd_cursor_right()		lcd_cmd(0x14)
#define lcd_cursor_left()		lcd_cmd(0x10)
#define lcd_display_shift()		lcd_cmd(0x1C)
#define lcd_home()				lcd_cmd(0x2)

 void lcd_cmd(unsigned char);
 void lcd_data(unsigned char);
 void lcd_puts(const char * s);
 void lcd_init();
 void lcd_PutchDec(unsigned char c);
 void lcd_putchhex(unsigned char c);
 void lcd_putchlong(unsigned long c);

#endif

